	 	/*******************************************************************
        * 							  								********
       **  Sir Drink a lots Timerem                      v 3.0    	******** 
      ***  v3.0 (08.01.07)                                         	******* 
     ****  INFO:  Announces the time remaining before mapchange.  	****** 
    *****  It uses Game_Commencing for starting timer and	  		***** 
   ******  checks every second the cvar mp_timelimit,		  		**** 
  *******  to display the correct time. 			  				*** 
 ********  Thanks to Warhead,Black Knight,Schnuffer and the       	**
*********  www.admin-mod.de forumusers for help	and the idea	  	*
*********************************************************************/ 
#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>
#define ACCESS_CONSOLE 131072
#define ACCESS_BAN 256

new Key[]="am_sound";

new STRING_VERSION[MAX_DATA_LENGTH] = "3.0_2.50.60";
new g_checktime;
new g_origtimelimit;
new g_itime;
new g_checktimer;

//////////////////
// SPEAK-OUTPUT //
//////////////////
static OnesLib[10][] = { 
	"", "one ", "two ", "three ", "four ", "five ", "six ", "seven ", "eight ", "nine " 
};
static TensLib[10][] = {
	"", "ten ", "twenty ", "thirty ", "fourty ", "fifty ", "sixty ", "seventy ", "eighty ", "ninety " 
};
static TeensLib[10][] = {
	"", "eleven ", "twelve ", "thirteen ", "fourteen ", "fifteen ", "sixteen ", "seventeen "
	, "eighteen ", "nineteen " 
};
static HundredsLib[10][] = { 
	"", "one hundred ", "two hundred ", "three hundred ", "four hundred ", "five hundred ", 
	"six hundred ", "seven hundred ", "eight hundred ", "nine hundred " 
};
static GroupNamesLib[5][] = {
	"", "thousand ", "million ", "billion ", "trillion " 
};

#define timer_settings	19
new g_timer_output[timer_settings] = {1800,1500,1200,900,600,300,120,60,30,10,9,8,7,6,5,4,3,2,1};


public plugin_init() {
	plugin_registerinfo("Timeremember 3","Announces time remaining on map. Created by Sir D.",STRING_VERSION);
	plugin_registercmd("lt_welt", "lt_welt", ACCESS_CONSOLE);
	plugin_registercmd("admin_timerem","admin_timerem",ACCESS_BAN,"admin_timerem: Displays time remains");
	g_origtimelimit = getvar("mp_timelimit")*60;
	g_checktime = systemtime();
	g_checktimer = set_timer("lt_timecheck",1,99999);	
	exec("logd_reg 62 admin_command lt_welt");
	return PLUGIN_CONTINUE;
}

public admin_timerem(HLCommand,HLData,HLUserName,UserIndex) {
	speak_timeleft();
	return PLUGIN_HANDLED;
}

public lt_welt(HLCommand,HLData,HLUserName,UserIndex) {
	new Data [MAX_DATA_LENGTH];		
	convert_string( HLData, Data, MAX_DATA_LENGTH );		
	if(Data[0]=='G' || Data[8]=='R'){
		g_checktime = systemtime();
		//If it did not start at plugin init, restart here
		if(g_checktimer==0){
			g_checktimer = set_timer("lt_timecheck",1,99999);
		}
	}
	return PLUGIN_CONTINUE;
}

public lt_timecheck(Timer,Repeat,HLUser,HLParam) {
	new i;
	
	if (getvar("mp_timelimit")*60 != g_origtimelimit) {
		g_checktime = systemtime()-(systemtime()- g_checktime);
		g_origtimelimit= getvar("mp_timelimit")*60;	
	}
				 
	g_itime = g_origtimelimit-(systemtime()-g_checktime);
		
	for(i=0;i<=timer_settings;i++){
		if(g_itime==g_timer_output[i]){
			speak_timeleft();
		}
	}
	return PLUGIN_CONTINUE;
}

speak_timeleft(){
	new Text[MAX_TEXT_LENGTH];
	new User[MAX_NAME_LENGTH];
	new Minutes[MAX_NUMBER_LENGTH];
	new Seconds[MAX_NUMBER_LENGTH];
	new NextMap[MAX_NAME_LENGTH];
	new minutes;
	new seconds;
	new maxplayers = maxplayercount();
	new i;
	
	minutes = g_itime/60;
	seconds= g_itime%60;
	
	snprintf(Minutes,MAX_NUMBER_LENGTH,"%i",minutes);
	
	if(seconds<10){
		snprintf(Seconds,MAX_NUMBER_LENGTH,"0%i",seconds);
	}else{
		snprintf(Seconds,MAX_NUMBER_LENGTH,"%i",seconds);
	}
	
	if(g_itime>10){
		snprintf(Text,MAX_TEXT_LENGTH,"%s:%s remaining",Minutes,Seconds);
	}else{
		nextmap(NextMap,MAX_NAME_LENGTH);
		snprintf(Text,MAX_TEXT_LENGTH,"%s`nNext map: %s",Seconds,NextMap);
	}
	
	centersay(Text,6,255,255,255);
	
	numtoword(minutes,Minutes,MAX_NUMBER_LENGTH);
	numtoword(seconds,Seconds,MAX_NUMBER_LENGTH);
	
	if(g_itime>10){
		if(seconds>0){
			snprintf(Text,MAX_DATA_LENGTH,"fvox/%s minutes %s seconds remaining",Minutes,Seconds );
		}else{
			snprintf(Text,MAX_DATA_LENGTH,"fvox/%s minutes remaining",Minutes);
		}
	}else{
		snprintf(Text,MAX_DATA_LENGTH,"vox/%s",Seconds );
	}
	
	for(i=1;i<=maxplayers;i++){
		if(playerinfo(i,User,MAX_NAME_LENGTH)){
			execclient(User,"timeleft");
			if(allowsound(User)){
				speakto(User,Text);
			}
		}
	}
}

allowsound(User[]){
	new Info[MAX_NUMBER_LENGTH];
	new iInfo;
	new Authid[MAX_AUTHID_LENGTH];
	get_userAuthID(User,Authid,MAX_AUTHID_LENGTH);
	if(strcmp(Authid,"BOT")!=0){
		get_userinfo(User,Key,Info,MAX_NUMBER_LENGTH);
		iInfo=strtonum(Info);
		if(strlen(Info)==0 || iInfo > 0){/*damit wird automatisch immer der Sound auf 1 gesetzt,wenn kein setinfo vorhanden, bis 'stop' eingegeben wird*/
			return 1;
		}
	}
	return 0;
}

/*Big THX to SR71GOKU for this code!*/
stock do_numtoword(iNum,str[],iLevel,iLength) {
	
	/* If there is more than one group of 3, then take care of the others first. */
	if(iNum >= 1000) do_numtoword(iNum / 1000,str,iLevel + 1,iLength);
	
	/* Grab the the first 3 digits only */
	iNum %= 1000;	
	
	/* Isolate each digit */
	new _hundreds = iNum / 100;
	new _tens = (iNum / 10) % 10;
	new _ones = iNum % 10;
	
	/* Take care of the teen numbers */
	if(_tens == 1 && _ones != 0) {
		snprintf(str,iLength,"%s%s%s%s",str,HundredsLib[_hundreds],TeensLib[_ones],GroupNamesLib[iLevel]);
	} else {
		snprintf(str,iLength,"%s%s%s%s%s",str,HundredsLib[_hundreds], TensLib[_tens], OnesLib[_ones],GroupNamesLib[iLevel]);
	}
	
	if(iLevel==0) str[strlen(str)-1] = 0; /* Gets rid of the trailing space*/
	return 1;
}

stock numtoword(iNum,str[],iLength) {
	/* Empties the first char of the string */
	str[0] = 0;
	str[iLength-1] = 0;
	if(iNum == 0) {
		snprintf(str,iLength,"zero");
		return 1;
	}
	if(iNum < 0) {
		iNum *= -1;
		snprintf(str,iLength,"negative ");
	}
	
	return do_numtoword(iNum,str,0,iLength); 
}
